
/**
 ******************************************************************************
 * @file    53l1a2_conf.h
 * @author  IMG SW Application Team
 * @brief   This file contains definitions for the ToF components bus interfaces
 *          when using the X-NUCLEO-53L1A2 expansion board
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef VL53L1A2_CONF_H
#define VL53L1A2_CONF_H

#include "stm32wlxx_hal.h"
#include "stm32wlxx_nucleo_bus.h"
#include "stm32wlxx_nucleo_errno.h"

#ifdef __cplusplus
extern "C" {
#endif

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */

/*
 * the 53L1A2 BSP driver uses this symbol to allocate a structure for each device
 * if you are only using the on-board sensor without break-out boards
 * change its to (1U) in order to save space in RAM memory
 */
#define RANGING_SENSOR_INSTANCES_NBR    (3U)

#define VL53L1A2_hi2c                   (hi2c2)

#define VL53L1A2_I2C_SCL_GPIO_PORT      BUS_I2C2_SCL_GPIO_PORT
#define VL53L1A2_I2C_SCL_GPIO_PIN       BUS_I2C2_SCL_GPIO_PIN
#define VL53L1A2_I2C_SDA_GPIO_PORT      BUS_I2C2_SDA_GPIO_PORT
#define VL53L1A2_I2C_SDA_GPIO_PIN       BUS_I2C2_SDA_GPIO_PIN

#define VL53L1A2_I2C_Init               BSP_I2C2_Init
#define VL53L1A2_I2C_DeInit             BSP_I2C2_DeInit
#define VL53L1A2_I2C_WriteReg           BSP_I2C2_Send
#define VL53L1A2_I2C_ReadReg            BSP_I2C2_Recv
#define VL53L1A2_GetTick                BSP_GetTick

#ifdef __cplusplus
}
#endif

#endif /* VL53L1A2_CONF_H */
